// Karma configuration
// Generated on Thu Apr 20 2017 17:49:15 GMT+0800 (CST)

module.exports = function(config) {
    config.set({
        basePath: '',

        browsers: ['ChromeHeadless'],

        frameworks: ['mocha', 'chai'],

        webpack: {
            mode: 'production',
            module: {
                rules: [
                    {
                        test: /\.css$/,
                        use: ['style-loader', 'css-loader'],
                    },
                    {
                        test: /\.scss$/,
                        use: ['style-loader', 'css-loader', 'sass-loader'],
                    },
                    {
                        test: /\.html/,
                        use: 'html-loader',
                    },
                ],
            },
        },

        files: [
            'node_modules/@babel/polyfill/dist/polyfill.js',
            'src/*.spec.js',
            'src/mjpg-playback-states/*.spec.js',
            {
                pattern: 'public/*.avi',
                watched: false,
                included: false,
                served: true,
            },
            {
                pattern: 'public/*.mp4',
                watched: false,
                included: false,
                served: true,
            },
            {
                pattern: 'public/validation-frames/*/*.jpg',
                watched: false,
                included: false,
                served: true,
            },
        ],

        proxies: {
            '/fixtures/': '/base/public/',
            '/validation-frames/': '/base/public/validation-frames/',
        },

        customHeaders: [{
            match: 'public/bE2VmYX4cmF1596Q-1541998851-1541998866.avi',
            name: 'Content-Length',
            value: 233252,
        }, {
            match: 'public/bE2VmYX4cmF1596Q-1541999152-1541999167.avi',
            name: 'Content-Length',
            value: 231050,
        }, {
            match: 'public/bE2VmYX4cmF1596Q-1541998851-1541999151.avi',
            name: 'Content-Length',
            value: 4285534,
        }, {
            match: 'public/bE2VmYX4cmF1596Q-1541999152-1541999451.avi',
            name: 'Content-Length',
            value: 4249048,
        }],

        exclude: [
            'src/ClapprStrategy.spec.js',
        ],

        preprocessors: {
            'src/*.js': ['webpack'],
            'src/*.spec.js': ['webpack', 'babel'],
            'src/*/*.spec.js': ['webpack', 'babel'],
        },

        reporters: ['progress', 'coverage'],

        port: 9876,

        colors: true,

        logLevel: config.LOG_INFO,

        autoWatch: true,

        singleRun: false,

        concurrency: Infinity,

        browserNoActivityTimeout: 40000000,
    });
};
