const path = require('path');

module.exports = {
    mode: 'production',
    entry: ['@babel/polyfill', './src/QinPlayer.js'],
    output: {
        path: path.resolve(__dirname, 'dist'),
        filename: 'bundle.js',
        library: 'QinPlayer',
        libraryTarget: 'umd',
    },
    module: {
        rules: [
            {
                test: /\.?js$/,
                exclude: /node_modules/,
                loader: 'babel-loader',
            },
            {
                test: /\.css$/,
                use: ['style-loader', 'css-loader'],
            },
            {
                test: /\.scss$/,
                use: ['style-loader', 'css-loader', 'sass-loader'],
            },
            {
                test: /\.html/,
                use: 'html-loader',
            },
        ],
    },
};
